%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Optimization routine for minimum transmission loss over frequency band(s)%                                             
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;

ehandle=@Wall_Transmission_Optimization_frequency_band;

%Initial values for optimization
Thickness1_i=0.007;
Thickness2_i=1.0e-2;
Thickness3_i=0.07e-2;
Thickness4_i=20e-3;
Thickness5_i=20e-3;

%Lower and upper optimization bounds for the individual layers
lb1=0.006;
lb2=0.8e-2;
lb3=0.06e-2;
lb4=18e-3;
lb5=4e-3;

ub1=0.009;
ub2=1.2e-2;
ub3=0.09e-2;
ub4=22e-3;
ub5=6e-3;

%Maximum number of optimization iterations
Iter=50;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%       Optimization for n frequency bands                               %
%       Uncomment the actual number of layers                            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %1 layer
% 
options = optimset('MaxIter',Iter);
E=fminsearchbnd(ehandle,[Thickness1_i],lb1,ub1,options);

%Optimized value 1 layer
Thickness1_o=E(1);

% %2 layers

% lb=[lb1,lb2];
% ub=[ub1,ub2];
% 
% options = optimset('MaxIter',Iter);
% E=fminsearchbnd(ehandle,[Thickness1_i,Thickness2_i],lb,ub,options);
% 
% %Optimized value 2 layers
% Thickness1_o=E(1);
% Thickness2_o=E(2);
% 
% %3 layers
% 
% lb=[lb1,lb2,lb3];
% ub=[ub1,ub2,ub3];
% 
% options = optimset('MaxIter',Iter);
% E=fminsearchbnd(ehandle,[Thickness1_i,Thickness2_i,Thickness3_i],lb,ub,options);
%   
% % %Optimized value 1 layers
% Thickness1_o=E(1);
% Thickness2_o=E(2);
% Thickness3_o=E(3);
 
% %4 layers

% lb=[lb1,lb2,lb3,lb4];
% ub=[ub1,ub2,ub3,ub4];
% 
% options = optimset('MaxIter',Iter);
% E=fminsearchbnd(ehandle,[Thickness1_i,Thickness2_i,Thickness3_i,Thickness4_i],lb,ub,options);
% 
% %Optimized value 4 layers
% Thickness1_o=E(1);
% Thickness2_o=E(2);
% Thickness3_o=E(3);
% Thickness4_o=E(4);
 
% %5 layers

% lb=[lb1,lb2,lb3,lb4,lb5];
% ub=[ub1,ub2,ub3,ub4,ub5];

% options = optimset('MaxIter',Iter);
% E=fminsearchbnd(ehandle,[Thickness1_i,Thickness2_i,Thickness3_i,Thickness4_i,Thickness5],lb,ub,options);

% %Optimized value 5 layers
% Thickness1_o=E(1);
% Thickness2_o=E(2);
% Thickness3_o=E(3);
% Thickness4_o=E(4);
% Thickness5_o=E(5);


